**    ModelEco : MODELisation en programmation mathmatique pour l'analyse ECOnomique de l'agriculure    **

*-----------------------------------------------------------------------------*
$Ontext
Nom             AlimentationAnimale
Sequence         1 - Initiation  la programmation mathmatique avec GAMS
Type             LP
Langage GAMS     Introduction au langage GAMS
Description      Exercice de formulation d'un programme linaire simple
                 Premier modle de programmation linaire
" Une entreprise d'alimentation animale produit des concentrs destins aux bovins  partir de diffrents types d'ingrdients :
protagineux (pois), crales (mais) et tourteaux (de soja).
 Les concentrs obtenus doivent avoir une teneur garantie minimale en MAT (matires azotes totales)
et en matires grasses et une teneur maximale en matires minrales et cellulose brute.
Teneurs minimums        MAT (g/kg)        Matires grasses (g/kg)
Concentr                 200                    25

Teneurs maximales        Matires minrales (g/kg)        Cellulose brute (g/kg)
Concentr                        70                              65

Chaque ingrdient a une teneur connue en chacun de ces composs.
Teneurs        MAT (g/kg)        Matires grasses (g/kg)        Matires minrales (g/kg)        Cellulose brute (g/kg)
Mais             81                      37                               12                             22
Pois             207                     10                               30                             52
Tourteau de soja 453                     19                               64                             60

Le cot du mais est de 148/T, celui des pois 195/T et celui des tourteaux de soja de 355/T.
L'entreprise souhaite trouver la formulation optimale du kilo de concentre de faon
 respecter les teneurs garanties tout en minimisant les cots de production. "


$Offtext
*-----------------------------------------------------------------------------*


*----------                          INDICES                        ----------*
SETS
I ingrdients / mais, pois, soja/
;


*----------                          DONNEES                        ----------*
SCALAR
TMin1    /200/
TMin2    /25/
TMax3    /70/
TMax4    /65/
;


*----------                         MODELE                          ----------*
PARAMETERS
TC1(I) teneurs connues en MAT en g par kg
/mais     81
pois     207
soja     453
/
TC2(I) teneurs connues en matires grasses en g par kg
/mais 37
pois 10
soja 19
/
TC3(I) teneurs connues en matires minrales en g par kg
/mais     12
pois     30
soja     64
/
TC4(I) teneurs connues en cellulose en g par kg
/mais 22
pois 52
soja 60
/
;

PARAMETERS
PX(I) prix des ingredients en euros par tonnes
/mais 0.148, pois 0.195, soja 0.355/
;

POSITIVE VARIABLE
X(I) quantit de chaque ingrdient pour un kilo de concentr      ;

VARIABLE
C cout total ;

EQUATIONS
OBJECTIF
T_MAT
T_matG
T_mineraux
T_cellulose
POIDS
;

OBJECTIF.. sum(I, PX(I)*X(I)) =e= C ;
T_MAT.. sum(I, TC1(I)*X(I)) =g= TMin1 ;
T_matG.. sum(I, TC2(I)*X(I)) =g= TMin2 ;
T_mineraux.. sum(I, TC3(I)*X(I)) =l= TMax3 ;
T_cellulose.. sum(I, TC4(I)*X(I)) =l= TMax4 ;
POIDS.. sum(I, X(I)) =e= 1 ;

MODEL concentre /all/ ;


*----------                        SOLUTION                         ----------*
SOLVE concentre using LP minimizing C ;
